*;
*  First attempt.
*;

ods listing close;
ods tagsets.ExcelXP path="&SAMPDIR" file='LabReport.xml' style=XLsansprinter;

title;
footnote;

*  Create the range flags worksheet;

proc print data=Legend noobs label;
  var Range;
  var LabFlag;
run; quit;

*  Create the lab results worksheets;

proc report data=sample.LabResults split='*' nowindows;
by protocol;

*  'ID' columns;

column Treat Patient LabSite Visit VisitDate;

*  Data columns with spanned headers;

column ('Haematology' Haemoglobin_Result Haematocrit_Result RBC_Result WBC_Result
         ('Differential' Lymphocytes_Result Monocytes_Result Neutrophils_Result
                         Eosinophils_Result Basophils_Result Platelets_Result
         )
       );

*  Hidden columns containing the range flags;

column Haemoglobin_Flag Haematocrit_Flag RBC_Flag WBC_Flag
       Lymphocytes_Flag Monocytes_Flag Neutrophils_Flag Eosinophils_Flag
       Basophils_Flag Platelets_Flag;


*  Dummy column to perform traffic lighting;

column dummy;

*  'ID' columns;

define Treat     / display order;
define Patient   / display order;
define LabSite   / display order;
define Visit     / display order;
define VisitDate / display;

*  Data columns;

define Haemoglobin_Result / display;
define Haematocrit_Result / display;
define RBC_Result         / display;
define WBC_Result         / display;
define Lymphocytes_Result / display;
define Monocytes_Result   / display;
define Neutrophils_Result / display;
define Eosinophils_Result / display;
define Basophils_Result   / display;
define Platelets_Result   / display;

*  Hidden columns containing the range flags;

define Haemoglobin_Flag / display noprint;
define Haematocrit_Flag / display noprint;
define RBC_Flag         / display noprint;
define WBC_Flag         / display noprint;
define Lymphocytes_Flag / display noprint;
define Monocytes_Flag   / display noprint;
define Neutrophils_Flag / display noprint;
define Eosinophils_Flag / display noprint;
define Basophils_Flag   / display noprint;
define Platelets_Flag   / display noprint;

*  Dummy column to perform traffic lighting;

define dummy / computed noprint;

*  Traffic light the data columns based on the hidden columns;

compute dummy;

  *  Place holder;

endcomp;

*  Insert a blank line between treatments;

compute after Treat;
  line ' ';
endcomp;

run; quit;

ods tagsets.ExcelXP close;